# Ds\Map::reduce

(PECL ds >= 1.0.0)

Ds\Map::reduce — Reduces the map to a single value using a callback function

### Descripción

public Ds\Map::reduce(callable `$callback`, mixed `$initial` = ?): mixed

Reduces the map to a single value using a callback function.

### Parámetros

`callback`
  callback(mixed `$carry`, mixed `$key`, mixed `$value`): mixed
  `carry`

    The return value of the previous callback, or `initial` if it's the first iteration.

  `key`

    The key of the current iteration.

  `value`

    The value of the current iteration.

`initial`

  The initial value of the carry value. Can be `null`.

### Valores devueltos

The return value of the final callback.

### Ejemplos

Ejemplo #1 Ds\Map::reduce() with initial value example

`<?php
$map = new \Ds\Map(["a" => 1, "b" => 2, "c" => 3]);
$callback = function($carry, $key, $value) {
return $carry * $value;
};
var_dump($map->reduce($callback, 5));
// Iterations:
//
// $carry = $initial = 5
//
// $carry = $carry * 1 = 5
// $carry = $carry * 2 = 10
// $carry = $carry * 3 = 30
?>`

El resultado del ejemplo sería algo similar a:

    int(30)

Ejemplo #2 Ds\Map::reduce() without an initial value example

`<?php
$map = new \Ds\Map(["a" => 1, "b" => 2, "c" => 3]);
var_dump($map->reduce(function($carry, $key, $value) {
return $carry + $value + 5;
}));
// Iterations:
//
// $carry = $initial = null
//
// $carry = $carry + 1 + 5 = 6
// $carry = $carry + 2 + 5 = 13
// $carry = $carry + 3 + 5 = 21
?>`

El resultado del ejemplo sería algo similar a:

    int(21)